package tech.nevets.dliteserver;

import java.io.IOException;
import java.io.OutputStream;
import java.nio.charset.StandardCharsets;
import java.util.*;

public class MessageDistributer extends OutputStream {
    private static List<Connection> userStreams = new ArrayList<>();
    private static MessageDistributer instance;
    private String buf = "";

    public MessageDistributer() {
        instance = this;
    }

    @Override
    public void write(int b) throws IOException {
        buf += (char) b;
        if (((char) b) == '\n') this.flush();
    }

    @Override
    public void flush() {
        for (Connection conn : userStreams) {
            try {
                conn.getOutputStream().write((conn.getUsername() + "> " + buf).getBytes(StandardCharsets.UTF_8));
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        buf = "";
    }

    private void writeSystem(String message) {
        for (Connection conn : userStreams) {
            try {
                conn.getOutputStream().write(("SERVER> " + message + "\n").getBytes(StandardCharsets.UTF_8));
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    public void registerStream(Connection conn) {
        int i = 0;
        String username;
        for (username = conn.getUsername(); existingUsername(username); username = conn.getUsername() + "." + i) {
            i++;
        }
        conn.updateUsername(username);
        userStreams.add(conn);
        writeSystem("Welcome " + username + "!");
    }

    private boolean existingUsername(String username) {
        for (Connection c : userStreams) {
            if (c.getUsername().equals(username)) return true;
        }
        return false;
    }

    private static MessageDistributer getInstance() {
        return instance;
    }

    public static void closeUserConnection(Connection conn) {
        userStreams.remove(conn);
        getInstance().writeSystem(("Goodbye, " + conn.getUsername() + "!"));
    }
}
